org 0x0000

mov ax, 0100h
mov ds, ax
mov es, ax

jmp start

;;;;;;;;;;;;;;;;;;;;;;;
CR equ 0x0D
LF equ 0x0A
size equ 50

buffer db size dup(0)
inp db "ShadOS 0.1> ", 0 
dosleer db '$'

tagname db "SoMoDiMiDoFrSa"
msg db "Unknown Command: $"
shelp db "Hilfe:",CR,LF
      db "zeit     - Zeit anzeigen",CR,LF
      db "help     - Hilfe",CR,LF
      db "exit     - Beenden",CR,LF
      db "$"

czeit db "zeit", 0
cexit db "exit", 0
chelp db "help", 0
;;;;;;;;;;;;;;;;;;;;;;;

 
start:
lea si,shelp
call DosString



schleife:
call Cursorpos;curserpos to bx
inc bh ;eine Zeile zwischen Befehlantworten frei lassen
mov dx,0x1800 ;24,0 Zeile,Spalte
call Locate
lea di,buffer
call clearbuffer
mov dx,0x1800
call Locate
lea si,inp
call Print
nop
lea di,buffer
mov dx,size
call Input
mov dx,bx
call Locate
call check
cmp dh,0x17 ;23 Zeile (0-24)
jge _scroll
_scrollback:
jmp schleife




check proc near
lea si,buffer

lea di,cexit
call same
cmp al,1
je _cexit

lea di,chelp
call same
cmp al,1
je _chelp

lea di,czeit
call same
cmp al,1
je _czeit

jmp _cunknown
back:
ret
check endp




_czeit:
pusha
mov ah,0x2A ;Datum
int 0x21
lea di,buffer
lea si,tagname ;tagname
push di
push si
xor ah,ah               
shl al,1 ;Tagnummer*2 (WORD)
add si,ax ;Weil ah=0 und nur al gebraucht und si=16bit, si=ax
lodsw
stosw
pop si
mov al,' '
stosb
xor ax,ax
mov al,dl ;Tag
call itoa
mov al,'.'
stosb
mov al,dh ;Monat
call itoa
mov al,'.'
stosb
mov ax,cx ;Jahr
call itoa
mov al,' '
stosb
mov ah,0x2C ;Zeit
int 0x21
xor ax,ax
mov al,ch ;Stunden
call itoa
mov al,':'
stosb
mov al,cl ;Minuten
call itoa
mov al,':'
stosb
mov al,dh ;Sekunden
call itoa
mov al,CR
stosb
mov al,LF
stosb
mov al,'$'
stosb
pop di
mov si,di
call DosString
popa
jmp back


_cexit:
call reboot
;jmp back

_chelp:
lea si,shelp
call DosString
jmp back

_cunknown:
lea si,msg
call DosString
lea si,buffer
call ShowString
putc CR
putc LF
jmp back







_scroll:
sub dh,10
call Locate
mov cx,10
_scrollfor:
mov ah,0x09
lea dx,dosleer
int 0x21
dec cx
jnz _scrollfor
jmp _scrollback




d10 macro
push ax
push dx  
mov ax,bx
mov bx,10
xor dx,dx
div bx
mov bx,ax
pop dx
pop ax   
endm
 
itoa proc near ;dont repairs di
push ax
push bx
push cx
push dx
xor cx,cx
mov bx,10000 ;hchste zehnerpotenz von einem word (65535-0)
itoa_for:
xor dx,dx
div bx
cmp ax,0
je itoa_check
itoa_back:
or cx,1
add al,'0'
stosb
itoa_weiter:
mov ax,dx
cmp bx,1
je itoa_ende
d10
jmp itoa_for
itoa_ende:
pop dx
pop cx
pop bx
pop ax
ret
itoa_check:
cmp cx,0
je itoa_weiter
jmp itoa_back
itoa endp
 
clearbuffer proc near
push cx
mov cx,12
clbuforc:
putc ' '
dec cx
jnz clbuforc
pop cx
push di
clbufor:
cmp [di],0
je clbuende
putc ' '
mov [di],0
inc di
jmp clbufor
clbuende:
pop di
ret    
clearbuffer endp

Locate proc near
push ax
push bx
mov ah,2
mov bh,0
int 0x10
pop bx
pop ax
ret
Locate endp

Cursorpos proc near
push ax
push cx
push dx
mov ah,3
mov bh,0 
int 0x10
mov bx,dx 
pop dx
pop cx
pop ax 
ret
Cursorpos endp

putc    macro   char ;copied
push    ax
mov     al, char
mov     ah, 0eh
int     10h
pop     ax
endm

Input proc near ;copied
push    ax
push    cx
push    di
push    dx
mov     cx, 0
cmp     dx, 1
jbe     empty_buffer
dec     dx
wait_for_key:
mov     ah, 0
int     16h
cmp     al, 0Dh
jz      exit
cmp     al, 8
jne     add_to_buffer
jcxz    wait_for_key
dec     cx
dec     di
putc    8
putc    ' '
putc    8
jmp     wait_for_key
add_to_buffer:
cmp     cx, dx
jae     wait_for_key
mov     [di], al
inc     di
inc     cx
mov     ah, 0eh
int     10h
jmp     wait_for_key
exit: 
mov     [di], 0
empty_buffer:
pop     dx
pop     di
pop     cx
pop     ax 
ret
Input endp

same proc near
push si
push di
mov al,0
sfor:
mov ah,[si]
cmp ah,[di]
jne e
inc si
inc di
cmp [si],0
jz sen
jmp sw:
sen:
cmp [di],0
jz se
sw:
jmp sfor
se:
mov al,1
e:
pop di
pop si
ret
same endp
  
Cls proc near
mov ax,3 ;Clear screen
int 0x10 ;Videomode
ret
Cls endp
  
Print proc near
push ax
push si
next:
mov al,[si]
cmp al,0
jz ende
inc si
mov ah,0x0E
int 0x10
jmp next
ende:
pop si
pop ax
ret
Print endp
   
reboot proc near
mov 	ax, 0040h
mov 	ds, ax
mov 	w.[0072h], 0000h
jmp	0ffffh:0000h
reboot endp   
   
ShowString proc near
push ax
push bx
push dx
push si
ssfor:
mov al,[si]
cmp al,0
je sss
inc si
jmp ssfor
sss:
mov [si],'$'
mov bx,si
pop si
push si
mov ah,0x09
mov dx,si
int 0x21
mov [bx],0 
pop si
pop dx
pop bx
pop ax
ret
ShowString endp

DosString proc near
push ax
push si
push dx
mov ah,0x09
mov dx,si
int 0x21  
pop dx
pop si
pop ax
ret
DosString endp


